package be.iminds.ilabt.jfed.experimenter_gui.canvas.gts;

import be.iminds.ilabt.jfed.experimenter_gui.canvas.CanvasNode;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.NewLinkTarget;
import be.iminds.ilabt.jfed.gts.model.impl.FXGtsType;
import javafx.geometry.Point2D;

/**
 * User: twalcari
 * Date: 2/9/2016
 * Time: 16:58
 */
public abstract class GtsCanvasType extends CanvasNode implements NewLinkTarget{

    private final FXGtsType type;

    protected GtsCanvasType(FXGtsType type) {
        this.type = type;

        this.layoutXProperty().bindBidirectional(type.editorXProperty());
        this.layoutYProperty().bindBidirectional(type.editorYProperty());

        translateXProperty().bind(widthProperty().multiply(-0.5));
        translateYProperty().bind(heightProperty().multiply(-0.5));
    }

    public FXGtsType getType() {
        return type;
    }

    @Override
    public Point2D getCenterPosition() {
        return new Point2D(NewLinkTarget.getCenterX(this), NewLinkTarget.getCenterY(this));
    }
}
